pipeline {
    agent any

    stages {
        stage('Build') {
            steps {
                bat "mvn clean package"
            }
        }
        stage('Test Analyse') {
            steps {
                echo "Test Stage"
                bat "mvn test"
                bat "mvn checkstyle:checkstyle"
                bat "mvn spotbugs:spotbugs"
                bat "mvn pmd:pmd"
            }

        }
        stage('Code Quality (Sonar)') {
            steps {
                echo "Sonar Stage"
                bat "mvn clean verify sonar:sonar -Dsonar.projectKey=presentation -Dsonar.host.url=http://localhost:9000 -Dsonar.login=${Sonar_Token}"
            }
        }
        stage('Publish') {
            steps {
                echo "Publish Stage"
                archiveArtifacts '/target/*.jar'

            }
        }
    }
    post {
        success {
            junit '**/target/surefire-reports/TEST-*.xml'

            recordIssues enabledForFailure: true, tools: [mavenConsole(), java(), javaDoc()]
            recordIssues enabledForFailure: true, tool: checkStyle()
            recordIssues enabledForFailure: true, tool: spotBugs()
            recordIssues enabledForFailure: true, tool: cpd(pattern: '**/target/cpd.xml')
            recordIssues enabledForFailure: true, tool: pmdParser(pattern: '**/target/pmd.xml')
                }
        }
}
